SystemOrganization addCategory: #'Prolog-Base'!


Collection subclass: #List
	instanceVariableNames: 'content link'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog-Base'!

List subclass: #EmptyList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog-Base'!

Object subclass: #Logic
	instanceVariableNames: 'answer varList unboundVars tempResult returnBlock outputStream'
	classVariableNames: 'BinaryOp Database'
	poolDictionaries: ''
	category: 'Prolog-Base'!

Object subclass: #LogicDontCare
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog-Base'!

Object subclass: #LogicRef
	instanceVariableNames: 'content'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog-Base'!

Object subclass: #LogicUnbound
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog-Base'!

List subclass: #Relation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog-Base'!

List class
	instanceVariableNames: ''!

EmptyList class
	instanceVariableNames: ''!

Logic class
	instanceVariableNames: ''!

LogicDontCare class
	instanceVariableNames: ''!

LogicRef class
	instanceVariableNames: ''!

LogicUnbound class
	instanceVariableNames: ''!

Relation class
	instanceVariableNames: ''!


!LogicRef methodsFor: 'accessing' stamp: 'spfa 6/16/2008 11:10'!
adaptToNumber: rcvr andSend: selector

	^ rcvr perform: selector with: self value! !

!List methodsFor: 'adding' stamp: 'mt 6/30/1999 12:00'!
addList: aList
    link class == EmptyList
        ifTrue: [
            link := aList]
        ifFalse: [
            (link isKindOf: List)
                ifTrue: [link addList: aList]
                ifFalse: [self error: 'can''t add to non-list']].
    ^aList! !

!Logic methodsFor: 'accessing' stamp: 'spfa 6/8/2008 20:49'!
addVarFrom: aList
"
  SH: 2004/11/21 BugFix
  SH: There was a problem in using include: here.....fixed 041026
"
    aList isEmpty ifTrue: [^self].

    (aList head isKindOf: List)
        ifTrue: [self addVarFrom: aList head]
        ifFalse: [
            ((aList head class == LogicRef and:
            [aList head value class == LogicUnbound]) and:
            [(varList includes: aList head) not])
                ifTrue: [
				varList add: aList head.
				]
			].
    self addVarFrom: aList tail! !

!EmptyList methodsFor: 'accessing' stamp: 'mt 6/28/1999 12:00'!
add: anObject
    | aList |
    aList := List with: anObject.
    aList become: self.
    ^aList! !

!List methodsFor: 'adding' stamp: 'mt 6/30/1999 12:00'!
add: anObject
    link class == EmptyList
        ifTrue: [
            link := List with: anObject]
        ifFalse: [
            (link isKindOf: List)
                ifTrue: [link add: anObject]
                ifFalse: [self error: 'can''t add to non-list']].
    ^anObject! !

!Relation methodsFor: 'adding' stamp: 'mt 6/28/1999 12:00'!
add: anObject
    (content isNil and: [link isNil])
        ifTrue: [
            content := anObject.
            link := EmptyList new]
        ifFalse: [super add: anObject].
    ^anObject! !

!Logic methodsFor: 'accessing' stamp: 'programmatic 6/30/1999 19:05'!
allValue: aLogicRef
        "Copy all the values to an instance
         the same class as the content of aLogicRef.
         If aLogicRef's content is a List, walk
         through all elements."
    | anAnswer aList |
    (aLogicRef isKindOf: LogicRef)
        ifTrue: [anAnswer := aLogicRef value]
        ifFalse: [anAnswer := aLogicRef].
    (anAnswer isKindOf: List)
        ifTrue: [
            anAnswer isEmpty ifTrue: [^anAnswer].
            aList := anAnswer.
            anAnswer := anAnswer class with:
                (self allValue: aList head).
            anAnswer tail: (self allValue: aList tail)].
    ^anAnswer! !

!Collection methodsFor: '*Prolog-Base' stamp: 'mt 6/28/1999 12:00'!
asList
    | aList pointer |
    aList := EmptyList new.
    self do: [:i |
        aList add: i.
        pointer isNil
            ifTrue: [pointer := aList]
            ifFalse: [pointer := pointer tail]].
    ^aList! !

!List methodsFor: 'accessing' stamp: 'mt 6/30/1999 12:00'!
at: anInteger
        "Answer the element at the position anInteger."
    | answer |
    anInteger < 1
        ifTrue: [self error: 'index less than 1'].
    anInteger = 1
        ifTrue: [^content]
        ifFalse: [
            self isLastNode
                ifFalse: [^link at: anInteger - 1]
                ifTrue: [self error: 'out of range']]! !

!LogicRef methodsFor: 'accessing' stamp: 'mt 6/28/1999 12:00'!
at: anObject
    ^self value at: anObject! !

!Logic methodsFor: 'query' stamp: 'mt 6/28/1999 12:00'!
buildQuery: aList
        "Private"
    | pred block |
    pred := aList head.
    self addVarFrom: pred tail.
    block :=
        (aList tail isEmpty
            ifTrue: [[self inferAnswer]]
            ifFalse: [self buildQuery: aList tail]).
    ^[self perform: pred head with:
        (Association
            key: pred tail
            value: block)]! !

!LogicRef methodsFor: 'accessing' stamp: 'mt 6/28/1999 12:00'!
content
    ^content! !

!LogicRef methodsFor: 'accessing' stamp: 'mt 6/28/1999 12:00'!
content: anObject
    content := anObject! !

!Logic class methodsFor: 'accessing' stamp: 'mt 6/28/1999 12:00'!
database
    ^Database! !

!Logic methodsFor: 'accessing' stamp: 'spfa 6/17/2008 01:41'!
doesNotUnderstand: aMessage

     | temp pred |

    (aMessage selector beginsWith: Logic prologKeyword)
		ifFalse: [^ super doesNotUnderstand: aMessage].

	"primitive"
	(self class canUnderstand: (temp := ('prim', aMessage selector, ':') asSymbol))
		ifTrue: [^ self perform: temp with: aMessage arguments first].

	"database lookup"
    temp := aMessage selector.
    pred := (temp copyFrom: (Logic prologKeyword size) + 1 to: temp size) asLowercase
        asSymbol.

    temp := Database at: pred ifAbsent: [^ self error: 'Undefined predicate: ', pred].
    ^self retrieve: (aMessage arguments at: 1) from: temp
! !

!LogicRef methodsFor: 'accessing' stamp: 'mt 6/28/1999 12:00'!
doesNotUnderstand: aMessage
    ^self value
        perform: aMessage selector
        withArguments: aMessage arguments! !

!Logic methodsFor: 'query' stamp: 'spfa 6/8/2008 21:17'!
doGoal: aRelation continue: aBlock
	"Try to satisfy aRelation as a goal."
	| blk mark |
	mark := unboundVars size.
	((aRelation isKindOf: List) and: [
	aRelation head isSymbol])
		ifFalse: [self error: 'not a goal'].
	blk := self
		perform: (Logic selectorForPredicate: aRelation head)
		with: (Association
			key: aRelation tail
			value: aBlock).
	[blk class == BlockContext]
		whileTrue: [blk := blk value].
	self unbindVar: mark! !

!Logic methodsFor: 'query' stamp: 'spfa 6/9/2008 08:57'!
doOneGoal: aRelation
	"Try to satisfy aRelation as a goal.
	 Answer true if success, else false."
	| blk mark |
	mark := unboundVars size.
	((aRelation isKindOf: List) and: [
	aRelation head isSymbol])
		ifFalse: [self error: 'not a goal'].
	blk := self
		perform: (Logic selectorForPredicate: aRelation head)
		with: (Association
			key: aRelation tail
			value: [^true]).
	[blk class == BlockContext]
		whileTrue: [blk := blk value].
	self unbindVar: mark.
	^false! !

!EmptyList methodsFor: 'accessing' stamp: 'mt 6/28/1999 12:00'!
do: aBlock
    ^self! !

!List methodsFor: 'enumerating' stamp: 'mt 6/30/1999 12:00'!
do: aBlock
        "Answer the receiver.  For each element in the receiver,
         evaluate aBlock with that element as the argument."
    | aNode |
    aNode := self.
    [aBlock value: aNode head.
     aNode := aNode tail.
     (aNode isKindOf: List) ifFalse: [^self].
     aNode isEmpty]
        whileFalse: []! !

!Logic methodsFor: 'private' stamp: 'programmatic 6/30/1999 19:04'!
first: assoc
        "Private -- Answer the first argument."
    | anAnswer |
    anAnswer := assoc key head.
    ^self value: anAnswer! !

!List class methodsFor: 'instance creation' stamp: 'bolot 7/28/1999 15:31'!
fromBraceStack: itsSize 
	"Answer an instance of me with itsSize elements, popped in reverse order from
	 the stack of thisContext sender.  Do not call directly: this is called by {1. 2. 3}
	 constructs."

	^((Array new: itsSize) fill: itsSize fromStack: thisContext sender) asList! !

!EmptyList methodsFor: 'accessing' stamp: 'mt 6/28/1999 12:00'!
head
        "Error, empty list does not have head."
    ^self error: 'Message not understood: head'! !

!List methodsFor: 'accessing' stamp: 'mt 6/30/1999 12:00'!
head
    ^content! !

!List methodsFor: 'accessing' stamp: 'mt 6/30/1999 12:00'!
head: anObject
    content := anObject! !

!List class methodsFor: 'instance creation' stamp: 'mt 6/28/1999 12:00'!
head: aObject tail: bObject
    ^self basicNew
        head: aObject;
        tail: bObject;
        yourself! !

!EmptyList methodsFor: 'as yet unclassified' stamp: 'spfa 6/8/2008 20:49'!
includes: anObject 
"SH: 2004/11/21 BugFix"

	^ false.! !

!List methodsFor: 'as yet unclassified' stamp: 'spfa 6/8/2008 20:49'!
includes: anObject 
"SH: 2004/11/21 BugFix"

	(self head == anObject) 
		ifTrue: [^ true.]
		ifFalse: [^ self tail includes: anObject.].! !

!Logic methodsFor: 'private' stamp: 'spfa 6/9/2008 13:52'!
inferAnswer
        "Private -- Add an Array of values to
         the answer collection."
    | anArray i |
    anArray := Array new: varList size.
    i := 1.
    varList do: [:x |
        anArray at: i put: (self allValue: x).
        i := i + 1].
    answer add: anArray.! !

!Logic methodsFor: 'private' stamp: 'spfa 6/8/2008 20:50'!
inferSmalltalk: aList var: bList

"SH: 2004/11/21 BugFix"

        "Private -- Handle query from Smalltalk. aList
         contains a list of predicates and
         bList is a list of unbound variables."

    | blk |

    varList := List new.
    answer := OrderedCollection new.
    returnBlock := [
        self unbindVar: 0.
        answer size = 0
            ifTrue: [^nil]
            ifFalse: [^answer asArray]].
    blk := self buildQuery: aList.
    [(blk := blk value) class == BlockContext]
        whileTrue: [].
    ^returnBlock value! !

!Logic class methodsFor: 'initialize-release' stamp: 'spfa 6/17/2008 10:27'!
initialize
        "Initialize Database."
    Database := IdentityDictionary new! !

!Logic methodsFor: 'initialization' stamp: 'mt 6/28/1999 12:00'!
initialize
        "Private -- Initialize instance variables."
    unboundVars := OrderedCollection new: 2000! !

!EmptyList methodsFor: 'accessing' stamp: 'mt 6/28/1999 12:00'!
isEmpty
    ^true! !

!List methodsFor: 'testing' stamp: 'mt 6/30/1999 12:00'!
isEmpty
    ^false! !

!List methodsFor: 'testing' stamp: 'bolot 8/4/1999 18:04'!
isLastNode
        "Answer true if receiver's link contains
         an EmptyList."
    ^link class == EmptyList or: [(link isKindOf: List) not]! !

!LogicRef methodsFor: 'accessing' stamp: 'mt 6/28/1999 12:00'!
lastNode
    | aNode |
    aNode := self.
    [aNode content class == LogicRef]
        whileTrue: [aNode := aNode content].
    ^aNode! !

!Logic methodsFor: 'query' stamp: 'mt 6/28/1999 12:00'!
match: x with: y
        "Private -- Answer true if x matches y, else
         answer false."
    | xLast yLast |
 "Transcript nextPutAll: x printString;nextPut: $ ;
 nextPutAll: y printString;cr."
    (x class == LogicDontCare or: [y class == LogicDontCare])
         ifTrue: [^true].
    (x class == LogicRef)
        ifTrue: [
            xLast := x lastNode.
            xLast value class == LogicUnbound
                ifTrue: [
                    unboundVars add: xLast.
                    xLast value: y.
                    ^true]
                ifFalse: [xLast := xLast value]]
        ifFalse: [xLast := x].
    (y class == LogicRef)
        ifTrue: [
            yLast := y lastNode.
            yLast value class == LogicUnbound
                ifTrue: [
                    unboundVars add: yLast.
                    yLast value: x.
                    ^true]
                ifFalse: [
                    yLast := yLast value]]
        ifFalse: [yLast := y].
    (xLast class == List) ifTrue: [
        (yLast class == List)
            ifTrue: [
                (self match: xLast head with: yLast head)
                    ifTrue: [^self
                        match: xLast tail
                        with: yLast tail]]
            ifFalse: [^false]].
    (xLast class == Relation) ifTrue: [
        (yLast class == Relation)
            ifTrue: [
                (self match: xLast head with: yLast head)
                    ifTrue: [^self
                        match: xLast tail
                        with: yLast tail]]
            ifFalse: [^false]].
    ^xLast = yLast! !

!EmptyList class methodsFor: 'accessing' stamp: 'mt 6/28/1999 12:00'!
new
    ^self basicNew! !

!List class methodsFor: 'instance creation' stamp: 'mt 6/28/1999 12:00'!
new
    ^EmptyList new! !

!Logic class methodsFor: 'instance creation' stamp: 'mt 6/28/1999 12:00'!
new
    ^super new initialize! !

!LogicRef class methodsFor: 'accessing' stamp: 'mt 6/28/1999 12:00'!
new
    ^super new value: LogicUnbound new! !

!Relation class methodsFor: 'instance creation' stamp: 'mt 6/28/1999 12:00'!
new
    ^super basicNew! !

!Logic methodsFor: 'accessing' stamp: 'spfa 6/17/2008 10:59'!
outputStream

	^ outputStream ifNil: [outputStream := WriteStream on: '']! !

!EmptyList methodsFor: 'accessing' stamp: 'mt 6/28/1999 12:00'!
printOne: aStream
        "Print nothing."! !

!List methodsFor: 'printing' stamp: 'mt 6/30/1999 12:00'!
printOne: aStream
    content printOn: aStream.
    aStream nextPut: $ .
    (link isKindOf: List)
        ifTrue: [link printOne: aStream]
        ifFalse: [
            aStream nextPutAll: '| '.
            link printOn: aStream]! !

!EmptyList methodsFor: 'accessing' stamp: 'spfa 6/17/2008 15:54'!
printOne: aStream with: separators
        "Print nothing."! !

!List methodsFor: 'printing' stamp: 'spfa 6/17/2008 15:54'!
printOne: aStream with: separators
    content printOn: aStream.
    aStream nextPutAll: separators.
    (link isKindOf: List)
        ifTrue: [link printOne: aStream with: separators]
        ifFalse: [
            aStream nextPutAll: '| '.
            link printOn: aStream]! !

!List methodsFor: 'printing' stamp: 'spfa 6/16/2008 22:23'!
printOn: aStream
    aStream nextPut: $[.
    self printOne: aStream.
    content ifNotNil: [aStream skip: -1].
    aStream nextPut: $]! !

!LogicDontCare methodsFor: 'accessing' stamp: 'mt 6/28/1999 12:00'!
printOn: aStream
    aStream nextPutAll: '_';
        nextPut: $ ! !

!LogicRef methodsFor: 'accessing' stamp: 'mt 6/28/1999 12:00'!
printOn: aStream
    self value printOn: aStream! !

!LogicUnbound methodsFor: 'accessing' stamp: 'spfa 6/16/2008 10:40'!
printOn: aStream
    #Unbound printOn: aStream.
	self hash printOn: aStream
! !

!Relation methodsFor: 'printing' stamp: 'spfa 6/17/2008 15:57'!
printOn: aStream
	content isSymbol
		ifTrue: [aStream nextPutAll: content]
		ifFalse: [content printOn: aStream].
    aStream nextPut: $(.
    (link isKindOf: List)
        ifTrue: [link printOne: aStream with: ', '. link isEmpty ifFalse: [aStream skip: -2]]
        ifFalse: [link printOn: aStream].
    aStream nextPut: $)! !

!Logic class methodsFor: 'as yet unclassified' stamp: 'spfa 6/8/2008 21:25'!
prologKeyword

	^ 'logic'
! !

!Logic methodsFor: 'query' stamp: 'mt 6/28/1999 12:00'!
retrieve: assoc from: dataList
        "Retrieve a fact in assoc from
         Database entry dataList."
    | aList |
    dataList isEmpty ifTrue: [^self].
    aList := dataList.
    [aList isLastNode] whileFalse: [
        self unify: assoc key
            with: aList head
            then: assoc value.
        aList := aList tail].
    self unify: assoc key
        with: aList head
        then: [^assoc value]! !

!Logic methodsFor: 'private' stamp: 'programmatic 6/30/1999 19:05'!
second: assoc
        "Private -- Answer the second argument."
    | anAnswer |
    anAnswer := assoc key tail head.
    ^self value: anAnswer! !

!Logic class methodsFor: 'as yet unclassified' stamp: 'spfa 6/8/2008 21:20'!
selectorForPredicate: aString

	^ (self prologKeyword, (aString first: 1) asUppercase, aString allButFirst) asSymbol! !

!EmptyList methodsFor: 'accessing' stamp: 'mt 6/28/1999 12:00'!
size
    ^0! !

!List methodsFor: 'accessing' stamp: 'mt 6/30/1999 12:00'!
size
    ^1 +
        ((link isKindOf: List)
            ifTrue: [link size]
            ifFalse: [0])! !

!LogicDontCare methodsFor: 'parser support' stamp: 'bolot 7/19/1999 17:55'!
size
	" symbol used for LogicDontCare is '_' (underscore) "
	^self printString size! !

!Logic methodsFor: 'accessing' stamp: 'bolot 7/7/1999 19:52'!
structureHead: aSymbol arguments: anInteger
        "Answer a structure whose functor is
         aSymbol and arguments are anInteger
         number of DontCares."
    | aRelation |
    aRelation := Relation with: aSymbol.
    anInteger timesRepeat: [
        aRelation add: LogicDontCare new].
    ^aRelation! !

!EmptyList methodsFor: 'accessing' stamp: 'mt 6/28/1999 12:00'!
tail
        "Error, empty list does not have tail."
    ^self error: 'Message not understood: tail'! !

!List methodsFor: 'accessing' stamp: 'mt 6/30/1999 12:00'!
tail
    ^link! !

!List methodsFor: 'accessing' stamp: 'mt 6/30/1999 12:00'!
tail: anObject
    link := anObject! !

!Logic methodsFor: 'private' stamp: 'spfa 6/17/2008 14:13'!
third: assoc
        "Private -- Answer the third argument."
    | anAnswer |
    anAnswer := assoc key tail tail head.
    ^self value: anAnswer! !

!Logic methodsFor: 'private' stamp: 'mt 6/28/1999 12:00'!
unbindVar: mark
        "Private -- Unbind previously bound variables
         down to mark."
    | index |
    [(index := unboundVars size) > mark]
        whileTrue: [
            (unboundVars at: index)
                content: LogicUnbound new.
            unboundVars removeLast]! !

!Logic methodsFor: 'query' stamp: 'bolot 7/28/1999 23:09'!
unify: x with: y then: aBlock
        "Private -- If x unifies with y, then execute
         aBlock. Answer self."
    | mark |
"Transcript show: x printString, ' ', y printString; cr."
    mark := unboundVars size.
    (self match: x with: y)
        ifTrue:
            [tempResult := aBlock.
             [(tempResult := tempResult value).
              tempResult class == BlockContext]
                whileTrue: []].
    self unbindVar: mark! !

!LogicRef methodsFor: 'accessing' stamp: 'mt 6/28/1999 12:00'!
value
    | aNode |
    aNode := content.
    [aNode class == LogicRef]
        whileTrue: [aNode := aNode content].
    ^aNode! !

!Logic methodsFor: 'accessing' stamp: 'mt 6/28/1999 12:00'!
value: aRef
        "Private -- Answer the value of the
         logic ref, aRef."
    aRef class == LogicRef
        ifTrue: [^aRef value]
        ifFalse: [^aRef]! !

!LogicRef methodsFor: 'accessing' stamp: 'mt 6/28/1999 12:00'!
value: anObject
    | node |
    node := self lastNode.
    anObject class == LogicRef
        ifTrue: [
            node == anObject lastNode
                ifFalse: [node content: anObject]]
        ifFalse: [
            node content: anObject]! !

!List class methodsFor: 'instance creation' stamp: 'mt 6/28/1999 12:00'!
with: anObject
    ^self basicNew
        head: anObject;
        tail: EmptyList new! !

!List class methodsFor: 'instance creation' stamp: 'mt 6/28/1999 12:00'!
with: anObject with: bObject
    ^self basicNew
        head: anObject;
        tail: (List with: bObject)! !

!EmptyList methodsFor: 'accessing' stamp: 'mt 6/28/1999 12:00'!
= anObject
    ^anObject class == EmptyList! !

!LogicDontCare methodsFor: 'accessing' stamp: 'mt 6/28/1999 12:00'!
= anObject
    ^true! !

!LogicRef methodsFor: 'accessing' stamp: 'mt 6/28/1999 12:00'!
= anObject
    ^self value = anObject! !

!LogicRef methodsFor: 'accessing' stamp: 'mt 6/28/1999 12:00'!
== anObject
    ^self value == anObject! !
Logic initialize!
