SystemOrganization addCategory: #'Prolog-Documentation'!


Prolog subclass: #FisherTutorial
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog-Documentation'!

FisherTutorial subclass: #Chapter2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog-Documentation'!

FisherTutorial subclass: #Chapter3
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog-Documentation'!

FisherTutorial class
	instanceVariableNames: ''!

Chapter2 class
	instanceVariableNames: ''!

Chapter3 class
	instanceVariableNames: ''!


!FisherTutorial commentStamp: '<historical>' prior: 0!
This class and its subclasses implements code from the on-line Prolog tutorial at:
http://www.csupomona.edu/~jrfisher/www/prolog_tutorial/contents.html!

!Chapter2 methodsFor: '2.17 animal game' stamp: 'spfa 6/17/2008 11:18'!
logicAlbatross

albatross() :- bird(),
             verify('appears in story Ancient Mariner'),
             verify('flys well').! !

!Chapter2 methodsFor: '2.7 lists' stamp: 'spfa 6/16/2008 22:14'!
logicAppend

append([x|y],z,[x|w]) :- append(y,z,w).
append([],x,x).! !

!Chapter2 methodsFor: '2.17 animal game' stamp: 'spfa 6/17/2008 11:43'!
logicAsk
ask(question) :-
    write('Does the animal have the following attribute: '),
    write(question),
    write('? '),
    readstring(response),
    nl(),
    remember(question,response).
! !

!Chapter2 methodsFor: '2.17 animal game' stamp: 'spfa 6/17/2008 11:20'!
logicBird
bird()      :- verify('has feathers'), !!.
bird()     :- verify('flys'), verify('lays eggs').! !

!Chapter3 methodsFor: '3.2 cut' stamp: 'spfa 6/16/2008 10:48'!
logicBlack

black(#b).                           
 ! !

!Chapter2 methodsFor: '2.17 animal game' stamp: 'spfa 6/17/2008 11:21'!
logicCarnivore
carnivore() :- verify('eats meat'), !!.
carnivore() :- verify('has pointed teeth'), 
             verify('has claws'),
             verify('has forward eyes').! !

!Chapter2 methodsFor: '2.8 change for a dollar' stamp: 'spfa 6/16/2008 22:45'!
logicChange

change([h,q,d,n,p]) :- 
    member(h,[0,1,2]),                     
    member(q,[0,1,2,3,4]),                  
    member(d,[0,1,2,3,4,5,6,7,8,9,10]) ,   
    member(n,[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20]),  
    is(s, (50*h) + (25*q) + (10*d) + (5*n)), 
    le(s, 100), 
    is(p,100-s). ! !

!Chapter2 methodsFor: '2.17 animal game' stamp: 'spfa 6/17/2008 11:13'!
logicCheetah

cheetah() :- mammal(), 
           carnivore(), 
           verify('has tawny color'),
           verify('has dark spots').! !

!Chapter3 methodsFor: '3.2 cut' stamp: 'spfa 6/16/2008 10:50'!
logicColor

color(p,'red') :- red(p),!!.
color(p,'black') :- black(p),!!.
color(p,'unknown').                            
 ! !

!Chapter2 methodsFor: '2.14 DFA parser' stamp: 'spfa 6/17/2008 12:01'!
logicDelta

delta(0,#a,1).   
delta(0,#b,0).
delta(1,#a,1).
delta(1,#b,2).
delta(2,#a,2).
delta(2,#b,2).! !

!Chapter2 methodsFor: '2.14 DFA parser' stamp: 'spfa 6/17/2008 12:09'!
logicDemo214

demo214() :-
	write('Parsing bbaabab:'),nl(),
	parse([#b,#b,#a,#a,#b,#a,#b]),
	write('Parsing bba:'),nl(),
 	parse([#b,#b,#a]).! !

!Chapter2 methodsFor: '2.2 factorial' stamp: 'spfa 6/16/2008 10:59'!
logicFactorial

factorial(0,1). 

factorial(n,f) :-  
   gt(n,0), 
   is(n1, n - 1), 
   factorial(n1,f1), 
   is(f, n * f1).! !

!Chapter2 methodsFor: '2.2 factorial' stamp: 'spfa 6/16/2008 11:15'!
logicFactorialT

factorialT(0,f,f). 

factorialT(n,a,f) :-  
    gt(n,0), 
    is(a1, n* a), 
    is(n1, n - 1), 
    factorialT(n1,a1,f).! !

!Chapter2 methodsFor: '2.14 DFA parser' stamp: 'spfa 6/17/2008 12:01'!
logicFinal

final(2).! !

!Chapter2 methodsFor: '2.17 animal game' stamp: 'spfa 6/17/2008 11:14'!
logicGiraffe

giraffe() :- ungulate(), 
           verify('has long neck'), 
           verify('has long legs').! !

!Chapter2 methodsFor: '2.17 animal game' stamp: 'spfa 6/17/2008 11:49'!
logicGo

go() :- 
      write('Answer yes or no to the following questions...'), nl(),
	 hypothesize(animal),
      write('I guess that the animal is: '),
      write(animal),
      nl(),
      undo().! !

!Chapter2 methodsFor: '2.17 animal game' stamp: 'spfa 6/17/2008 11:11'!
logicHypothesize

hypothesize(#cheetah) :- cheetah(), !!.
hypothesize(#tiger) :- tiger(), !!.
hypothesize(#giraffe)   :- giraffe(), !!.
hypothesize(#zebra)     :- zebra(), !!.
hypothesize(#ostrich)   :- ostrich(), !!.
hypothesize(#penguin)   :- penguin(), !!.
hypothesize(#albatross) :- albatross(), !!.
hypothesize(#unknown).  ! !

!Chapter2 methodsFor: '2.17 animal game' stamp: 'spfa 6/17/2008 11:19'!
logicMammal
mammal()    :- verify('has hair'), !!.
mammal()   :- verify('gives milk').! !

!Chapter2 methodsFor: '2.17 animal game' stamp: 'spfa 6/17/2008 11:16'!
logicOstrich

ostrich() :- bird(),  
           verify('does not fly'), 
           verify('has long neck').! !

!Chapter3 methodsFor: '3.1 basics' stamp: 'spfa 6/9/2008 10:43'!
logicP

p(#a).                        
p(x) :- q(x), r(x).            
p(x) :- u(x).  ! !

!Chapter2 methodsFor: '2.14 DFA parser' stamp: 'spfa 6/17/2008 12:01'!
logicParse

parse(l) :- start(s), 
	trans(s,l).! !

!Chapter2 methodsFor: '2.17 animal game' stamp: 'spfa 6/17/2008 11:17'!
logicPenguin

penguin() :- bird(),  
           verify('does not fly'), 
           verify('swims'), 
           verify('is black and white').! !

!Chapter2 methodsFor: '2.7 lists' stamp: 'spfa 6/16/2008 22:12'!
logicPerm

perm([x|y],z) :- perm(y,w), takeout(x,z,w).   
perm([],[]).! !

!Chapter3 methodsFor: '3.1 basics' stamp: 'spfa 6/9/2008 09:45'!
logicQ

q(x) :- s(x). ! !

!Chapter3 methodsFor: '3.1 basics' stamp: 'spfa 6/9/2008 10:43'!
logicR

r(#a).                          
r(#b).                            
 ! !

!Chapter3 methodsFor: '3.2 cut' stamp: 'spfa 6/16/2008 10:48'!
logicRed

red(#a).                           
 ! !

!Chapter2 methodsFor: '2.17 animal game' stamp: 'spfa 6/17/2008 11:42'!
logicRemember
remember(question,'yes') :- database(yes()), assert(yes(question)).
remember(question,'y') :- database(yes()), assert(yes(question)).
remember(question,'no') :- database(no()), assert(no(question)), fail().
remember(question,'n') :- database(no()), assert(no(question)), fail().
! !

!Chapter2 methodsFor: '2.7 lists' stamp: 'spfa 6/16/2008 22:06'!
logicReverse

reverse([x|y],z,w) :- reverse(y,[x|z],w).
reverse([],x,x).
reverse(a,r) :- reverse(a,[],r).! !

!Chapter3 methodsFor: '3.1 basics' stamp: 'spfa 6/9/2008 10:43'!
logicS

s(#a).      
s(#b).          
s(#c).                           
 ! !

!Chapter2 methodsFor: '2.14 DFA parser' stamp: 'spfa 6/17/2008 12:01'!
logicStart

start(0).! !

!Chapter2 methodsFor: '2.7 lists' stamp: 'spfa 6/16/2008 12:34'!
logicTakeout

takeout(x,[x|r],r).
takeout(x,[f|r],[f|s]) :- takeout(x,r,s).! !

!Chapter2 methodsFor: '2.17 animal game' stamp: 'spfa 6/17/2008 11:14'!
logicTiger

tiger() :- mammal(), 
           carnivore(), 
           verify('has tawny color'),
           verify('has black stripes').! !

!Chapter2 methodsFor: '2.14 DFA parser' stamp: 'spfa 6/17/2008 12:01'!
logicTrans

trans(x,[a|b]) :- 
      delta(x,a,y),   
      write(x),
      write('  '),
      write([a|b]),
      nl(),
      trans(y,b).  
trans(x,[]) :- 
      final(x),
      write(x),
      write('  '),
      write([]), nl().
! !

!Chapter3 methodsFor: '3.1 basics' stamp: 'spfa 6/9/2008 10:43'!
logicU

u(#d).                           
 ! !

!Chapter2 methodsFor: '2.17 animal game' stamp: 'spfa 6/17/2008 11:31'!
logicUndo
undo() :- retract(yes(_)),fail(). 
undo() :- retract(no(_)),fail().
! !

!Chapter2 methodsFor: '2.17 animal game' stamp: 'spfa 6/17/2008 11:21'!
logicUngulate
ungulate() :- mammal(), 
            verify('has hooves'), !!.
ungulate() :- mammal(), 
            verify('chews cud').! !

!Chapter2 methodsFor: '2.17 animal game' stamp: 'spfa 6/17/2008 11:40'!
logicVerify

verify(s) :- database(yes()),yes(s), true().
verify(s) :- database(no()),no(s), fail().
verify(s) :- or(yes(s),or(no(s),ask(s))).
! !

!Chapter2 methodsFor: '2.17 animal game' stamp: 'spfa 6/17/2008 11:15'!
logicZebra

zebra() :- ungulate(), 
           verify('has black stripes').! !
