SystemOrganization addCategory: #'Prolog-Tests'!


TestCase subclass: #PrologTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog-Tests'!

PrologTest class
	instanceVariableNames: ''!


!PrologTest methodsFor: 'as yet unclassified' stamp: 'spfa 6/17/2008 15:40'!
testArg

	| v |

	{
		'arg(2,f(3,4,5,6),x)' -> #((4)).
		'arg(n,f(3,8,9,20,4,5,6),4)' -> #((5)).
		'arg(2,f(3,n,5,6),7)' -> #((7)).
	}
	do: [:assoc | 
		self assert: (Prolog evaluate: assoc key) = assoc value].

	v := Prolog evaluate: 'arg(2,f(3,n,5,6),x)'.
	self assert: v size = 1.
	self assert: v first first class == LogicUnbound.
	self assert: v first first == v first second. ! !

!PrologTest methodsFor: 'as yet unclassified' stamp: 'spfa 6/17/2008 22:38'!
testArg2

	{
		'eq(x,f(1,2,3)), arg(2,x,v)' -> '(f(1, 2, 3) 2)'.
		'eq(x,f(3,2,6)), arg(n,x,3)' -> '(f(3, 2, 6) 1)'.
		'eq(x,f(3,u,6)), arg(2,x,27)' -> '(f(3, 27, 6) 27)'.
	}
	do: [:assoc | 
		self assert: (String streamContents: [:str | 
					(Prolog evaluate: assoc key) first printElementsOn: str]) = assoc value].
! !

!PrologTest methodsFor: 'as yet unclassified' stamp: 'spfa 6/16/2008 23:42'!
testDatabase

	{
		'purgeDatabase(brother()).' 
			-> nil.
		'database(brother())' 
			-> #(()).
		'assertz(brother(''John'', ''Stewart'')),
					asserta(brother(''John'', ''Barbara'')), assertz(brother(''John'', ''Alan'')).'
			-> #(()).
		'brother(x,y)'
			->  #(#('John' 'Barbara') #('John' 'Stewart') #('John' 'Alan')).
		'retract(brother(''John'', ''Stewart''))'
			-> #(()).
		'brother(x,y)'
			->  #(#('John' 'Barbara') #('John' 'Alan')).
		'purgeDatabase(brother()).' 
			-> #(()).
	}
	do: [:assoc | 
		self assert: (Family evaluate: assoc key) = assoc value]! !

!PrologTest methodsFor: 'as yet unclassified' stamp: 'spfa 6/16/2008 23:40'!
testFamily

	{
		'father(x,y)' 
			-> #(('John' 'Mary') ('John' 'David') ('David' 'Jack') ('Arthur' 'Nancy')).
		'grandPa(''John'',y)' 
			-> #(('Nancy') ('Jack')).
		'father(x, ''Mary'')'
			-> #(('John')).
		'grandPa(''John'', x), father(y, x)'
			->  #(('Nancy' 'Arthur') ('Jack' 'David')).
		'father(''John'', ''Mary'')'
			-> #(()).
		'health(''John'', y)'
			->  #(('John had two times of heart attacks')).
		'consult( healthHistory(''John'', x), Doctor new)'
			->  #(('John had two times of heart attacks')).
	}
	do: [:assoc | self assert: (Family evaluate: assoc key) = assoc value]! !

!PrologTest methodsFor: 'as yet unclassified' stamp: 'spfa 6/16/2008 23:38'!
testFisherCh2

	{
		"http://www.csupomona.edu/~jrfisher/www/prolog_tutorial/2_2.html"

		'factorial(3,w)' -> #((6)).
		'factorialT(5,1,f)' -> #((120)).

		"http://www.csupomona.edu/~jrfisher/www/prolog_tutorial/2_7.html"

		'member(2,[1,2,3])' -> #(()).
		'member(x,[1,2,3])' -> #((1) (2) (3)).
		'member([3,y], [[1,#a],[2,#m],[3,#z],[4,#v],[3,#p]])' -> #((z) (p)).
		'member(x,[23,45,67,12,222,19,9,6]), is(y, x*x), lt(y, 100)'
			-> #((9 81) (6 36)).

"		'takeout(x,[1,2,3],l)' -> #(#(1 [2 3 ]) #(2 [1 3 ]) #(3 [1 2 ]))."
"		'takeout(3,w,[#a,#b,#c])' -> #(#([3 #a #b #c ]) #([#a 3 #b #c ]) #([#a #b 3 #c ]) #([#a #b #c 3 ]))"

	}
	do: [:assoc | 
		self assert: (Chapter2 evaluate: assoc key) = assoc value]! !

!PrologTest methodsFor: 'as yet unclassified' stamp: 'spfa 6/16/2008 23:39'!
testFisherCh3

	{
		"http://www.csupomona.edu/~jrfisher/www/prolog_tutorial/3_1.html"

		'eq(p(x,f(y),#a), p(#a,f(#a),y))' -> #((a a)).
		'eq(p(x,f(y),#a),p(#a,f(#b),y))' -> nil.
"		'eq(p(x,f(y),#a) , p(z,f(#b),#a))' ->  #(('Unbound' b 'Unbound'))."
		'eq(p(x,f(y),#a) , p(z,f(#b),#a)), is(x, #d) ' -> #((d b d)).

		"http://www.csupomona.edu/~jrfisher/www/prolog_tutorial/3_2.html"

		'p(x)' -> #((a) (a) (b) (d)).
		'p(x),!!' -> #((a)).
		'r(x),!!,s(y)' -> #((a a) (a b) (a c)).
		'r(x), s(y), !!' -> #((a a)).

		'color(#a,c)' -> #(('red')).
		'color(#c,c)' -> #(('unknown'))
	}
	do: [:assoc | 
		self assert: (Chapter3 evaluate: assoc key) = assoc value]! !

!PrologTest methodsFor: 'as yet unclassified' stamp: 'spfa 6/17/2008 18:01'!
testSend

	| v |

	self assert: (Prolog evaluate: 'send(4,#@,[10],x)') first first = (4@10).
	self assert: (Prolog evaluate: 'send(4,#even,x)') = #((true)).
	self assert: (Prolog evaluate: 'send(4,#odd,x)') = #((false)).

	v := Prolog evaluate: 'is(m, Morph new), is(p, m value extent), is(true, p value isPoint)'.
	self assert: v size == 1.
	self assert: v first first isMorph.
	self assert: v first second isPoint.

	v := Prolog evaluate: 'send(Morph,#new,m), send(m,#extent,p), is(true, p value isPoint)'.
	self assert: v size == 1.
	self assert: v first first isMorph.
	self assert: v first second isPoint.
! !
